
#import "DocumentHandler.h"

@implementation DocumentHandler




- (void)HandleDocumentWithURL:(CDVInvokedUrlCommand*)command;
{
    __weak DocumentHandler* weakSelf = self;
    
    dispatch_queue_t asyncQueue = dispatch_get_global_queue(DISPATCH_QUEUE_PRIORITY_DEFAULT, 0);
    dispatch_async(asyncQueue, ^{
        
        NSDictionary* dict = [command.arguments objectAtIndex:0];
        NSString* urlStr = dict[@"url"];
        NSURL* url = [NSURL URLWithString:urlStr];
      
        NSURLSession *session = [NSURLSession sharedSession];
        NSURLSessionDownloadTask *task = [session downloadTaskWithURL:url completionHandler:^(NSURL *location, NSURLResponse *response, NSError *error) {
          NSHTTPURLResponse *httpResponse = (NSHTTPURLResponse *) response;
          long statuscode = (long)[httpResponse statusCode];
          if (error || statuscode != 200) {
            CDVPluginResult *commandResult = [CDVPluginResult resultWithStatus:CDVCommandStatus_ERROR messageAsInt:2];
            [weakSelf.commandDelegate sendPluginResult:commandResult callbackId:command.callbackId];
            return;
          }
          
          NSString *fileName = [NSString stringWithFormat:@"文件预览.%@", [response.suggestedFilename pathExtension]];
          NSString* path = [NSTemporaryDirectory() stringByAppendingPathComponent: fileName];
          [[NSFileManager defaultManager] removeItemAtPath:path error:nil];
          NSURL* tmpFileUrl = [[NSURL alloc] initFileURLWithPath:path];
          [[NSFileManager defaultManager] moveItemAtURL:location toURL:tmpFileUrl error:nil];
          
          weakSelf.fileUrl = tmpFileUrl;
        
        dispatch_async(dispatch_get_main_queue(), ^{
            QLPreviewController* cntr = [[QLPreviewController alloc] init];
            cntr.delegate = weakSelf;
            cntr.dataSource = weakSelf;
        
            UIViewController* root = [[[UIApplication sharedApplication] keyWindow] rootViewController];
            [root presentViewController:cntr animated:YES completion:nil];
        });
        
        CDVPluginResult *commandResult = [CDVPluginResult resultWithStatus:CDVCommandStatus_OK messageAsString:@""];
        [weakSelf.commandDelegate sendPluginResult:commandResult callbackId:command.callbackId];
        }];
      
        // 4.启动任务
        [task resume];
      
        });

}

#pragma mark - QLPreviewController data source

- (NSInteger) numberOfPreviewItemsInPreviewController: (QLPreviewController *) controller
{
    return 1;
}

- (id <QLPreviewItem>) previewController: (QLPreviewController *) controller previewItemAtIndex: (NSInteger) index
{
    return self;
}

#pragma mark - QLPreviewItem protocol

- (NSURL*)previewItemURL
{
    return self.fileUrl;
}

@end
